;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;
; FileName	CeCall.s
; Type		ARM Assembler
; Description	Library that exports methods to enable dynamic invokes of 
;		functions in native libraries for the .Net CE Framework.
; Version	0.9
; Timestamp	19:00 5/09/2010
; 
;
	EXPORT invoke
	EXPORT invoke2
	EXPORT _DllMainCRTStartup
	 	
 	AREA .code, CODE, ALIGN=4 

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;
_DllMainCRTStartup PROC
	mov r0, #1
	mov pc, lr
	ENDP

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;
;	invoke pfunc,arg1,arg2,arg3,arg4,...,arg~
;
	ALIGN 4
invoke	PROC
	ldr r12, =dwLR	; load the address of dwLR into r12
	str lr, [r12]	; store link register(lr) in dwLR location
	
	mov r12, r0	; move function ptr in register 0 to register 12

	mov r0, r1	; move first argument from register 1 to register 0
	mov r1, r2	; move second argument from register 2 to register 1
	mov r2, r3	; move third argument from register 3 to register 2

	ldr r3, [sp]	; load the fourth argument from the stack into to register 3 

	add sp, sp, #4	; add 4 to the stack pointer, let it point to the fifth argument

	mov lr, pc	; set return address, (add 8 to the program counter(pc) 
			; and store in the link register(lr))

	mov pc, r12	; mov function address from register 12 into the program counter(pc)

	sub sp, sp, #4	; subtract 4 from the stack pointer(sp)

	ldr r1, =dwLR	; load the address of dwLR into r1
	ldr lr, [r1]	; load the value from register 1 into the link register(lr)
	
	mov pc, lr	; move the link register(lr) to the program counter(pc) = return
	
	; maybe change previous 2 lines into "ldr pc, [r1]"
	; i've chosen to restore the link register too, 
	; in case that is expected
	ENDP

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;
;	invoke pfunc,arg1,arg2,arg3
;
	ALIGN 4
invoke2 PROC 
	mov r12, r0	; move function ptr in register 0 to register 12

	mov r0, r1	; move first argument from register 1 to register 0
	mov r1, r2	; move second argument from register 2 to register 1
	mov r2, r3	; move third argument from register 3 to register 2

	mov pc, r12	; move register 12 to the program counter(pc)
	ENDP

	ALIGN 4
	LTORG

	AREA .data, DATA, READWRITE, ALIGN=4

dwLR	DCD 0x00000000 

	END
