﻿using System;
using System.Runtime.InteropServices;

namespace UnitTest
{
    class EntryPoint
    {
        [DllImport("CeCall.dll", EntryPoint = "invoke")]
        static extern Int32 MessageBox(IntPtr pMessageBox, IntPtr hWndParent, String text, String title, UInt32 options);
       
        [DllImport("CeCall.dll", EntryPoint ="invoke2")]
        static extern IntPtr GetForegroundWindow(IntPtr pGetForegroundWindow);

        static void Main(string[] args)
        {
            IntPtr hModule = NativeMethods.GetModuleHandle("Coredll.dll");
            IntPtr pGetForeWnd = NativeMethods.GetProcAddress(hModule, "GetForegroundWindow");
            IntPtr hWnd = GetForegroundWindow(pGetForeWnd);
            IntPtr pProcedure = NativeMethods.GetProcAddress(hModule, "MessageBoxW");
            MessageBox(pProcedure, hWnd, "Dynamic invoke of a native function in CSharp for Windows Mobile...", "CeCall.dll", 0x40);
        }

        private sealed class NativeMethods
        {
            [DllImport("Coredll.dll", SetLastError = true)]
            public static extern IntPtr GetProcAddress(IntPtr module, String procName);

            [DllImport("Coredll.dll", SetLastError = true)]
            public static extern IntPtr GetModuleHandle(String fileName);
        }

    }

}
