﻿
Imports System
Imports System.Runtime.InteropServices
Imports Microsoft.VisualBasic

Namespace UnitTest

    Friend Class EntryPoint

        <DllImport("CeCall.dll", EntryPoint:="invoke")> _
        Shared Function MessageBox(ByVal pMessageBox As IntPtr, ByVal hWnd As IntPtr, ByVal message As String, ByVal title As String, ByVal options As Integer) As Integer
        End Function

	<DllImport("CeCall.dll", EntryPoint:="invoke2")> _
        Shared Function GetForegroundWindow(ByVal pGetForegroundWindow As IntPtr) As Intptr
        End Function

        Friend Shared Sub Main()
            ' Coredll is already loaded so GetModuleHandle works fine,...
            ' get a handle for coredll.dll
            Dim library As IntPtr = NativeMethods.GetModuleHandle("coredll.dll")
            ' get the address of the GetForegroundWindow function
            Dim pGFW As IntPtr = NativeMethods.GetProcAddress(library, "GetForegroundWindow")
            ' Call the GetForegroundWindow function
            Dim hWnd As IntPtr = GetForegroundWindow(pGFW)
            ' Get the address of MessageBoxW
            Dim pMsgBox As IntPtr = NativeMethods.GetProcAddress(library, "MessageBoxW")
            ' invoke messagebox thru our proto
            MessageBox(pMsgBox, hWnd, "Dynamic invoke of a native function in VB.Net for Windows Mobile...", "CeCall.dll", MsgBoxStyle.Information Or MsgBoxStyle.SystemModal)
        End Sub

        Private Class NativeMethods

            Private Const COREDLL_DLL As String = "Coredll.dll"

            <DllImport(COREDLL_DLL, SetLastError:=True)> _
            Friend Shared Function GetModuleHandle(ByVal fileName As String) As IntPtr
            End Function
            <DllImport(COREDLL_DLL, SetLastError:=True)> _
            Friend Shared Function GetProcAddress(ByVal library As IntPtr, ByVal procName As String) As IntPtr
            End Function

            '''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
            '
            ' Coredll is already loaded so GetModuleHandle works fine,...
            ' LoadLibrary must be used when loading a dll that is not loaded yet, 
            ' 
            ' Here are the declarations for import
            '
            '<DllImport(COREDLL_DLL, SetLastError:=True)> _
            'Friend Shared Function LoadLibrary(ByVal fileName As String) As IntPtr
            'End Function
            '<DllImport(COREDLL_DLL, SetLastError:=True)> _
            'Friend Shared Function FreeLibrary(ByVal library As IntPtr) As <MarshalAs(UnmanagedType.Bool)> Boolean
            'End Function

        End Class

    End Class

End Namespace
